; ---------------------------------------------------------------
; Butter Fly Handling
; These attempt to go clockwise
; ---------------------------------------------------------------

DoMoveButterFly:
   ; work out current direction
   ld a, (xde)
   and a, 0c0h
   cp a, BUTTERFLYRIGHT
   jp z, CheckButterFlyDown
   cp a, BUTTERFLYLEFT
   jp z, CheckButterFlyUp
   cp a, BUTTERFLYDOWN
   jp z, CheckButterFlyLeft
   jp CheckButterflyRight ; BUTTERFLYUP

CheckButterFlyUp:
   push xbc
   ld xbc, xde
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckButterFlyUp_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckButterFlyRight:
   push xbc
   ld xbc, xde
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckButterFlyRight_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckButterFlyDown:
   push xbc
   ld xbc, xde
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckButterFlyDown_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckButterFlyLeft:
   push xbc
   ld xbc, xde
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveButterFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveButterFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckButterFlyLeft_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

MoveButterFlyUp:
   push xde

   ; update the map
   ld a, TILEBUTTERFLYMOVED
   or a, BUTTERFLYUP ; set next direction
   ld (xde), a
   add xde, MAXLEVELWIDTH
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFU_End
   cp (InViewY), 1
   jr nz, MoveBFU_End
   
   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec l
   ld a, TILEBUTTERFLY
   call DrawBlockAt
   pop hl
   
MoveBFU_End:
   pop xde   
   jp CheckButterFlyUp_End


MoveButterFlyRight:
   push xde

   ; update the map
   ld a, TILEBUTTERFLYMOVED
   or a, BUTTERFLYRIGHT ; set next direction
   ld (xde), a
   dec xde
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFR_End
   cp (InViewY), 1
   jr nz, MoveBFR_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc h
   ld a, TILEBUTTERFLY
   call DrawBlockAt
   pop hl
   
MoveBFR_End:
   pop xde   
   jp CheckButterFlyRight_End


MoveButterFlyDown:
   push xde
   ; update the map
   ld a, TILEBUTTERFLYMOVED
   or a, BUTTERFLYDOWN ; set next direction
   ld (xde), a
   sub xde, MAXLEVELWIDTH
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFD_End
   cp (InViewY), 1
   jr nz, MoveBFD_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc l
   ld a, TILEBUTTERFLY
   call DrawBlockAt
   pop hl
   
MoveBFD_End:
   pop xde   
   jp CheckButterFlyDown_End


MoveButterFlyLeft:
   push xde

   ; update the map
   ld a, TILEBUTTERFLYMOVED
   or a, BUTTERFLYLEFT ; set next direction
   ld (xde), a
   inc xde
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFL_End
   cp (InViewY), 1
   jr nz, MoveBFL_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec h
   ld a, TILEBUTTERFLY
   call DrawBlockAt
   pop hl
   
MoveBFL_End:
   pop xde   
   jp CheckButterFlyLeft_End

; ---------------------------------------------------------------
; Butter Flies second animation
; ---------------------------------------------------------------
DoMoveButterFlyAnim:
   ; work out current direction
   and (xde), ~20h ; remove the moved flag
   ld a, (xde)
   and a, 0c0h
   cp a, BUTTERFLYRIGHT
   jp z, MoveButterFlyRightAnim
   cp a, BUTTERFLYLEFT
   jp z, MoveButterFlyLeftAnim
   cp a, BUTTERFLYDOWN
   jp z, MoveButterFlyDownAnim
   jp MoveButterFlyUpAnim ; BUTTERFLYUP

MoveButterFlyUpAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFUA_End
   cp (InViewY), 1
   jr nz, MoveBFUA_End
   
   push hl
   inc l
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MBFUA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec l
   ld a, TILEBLANK
   call DrawBlockAt
MBFUA1:
   pop hl

   ld a, TILEBUTTERFLY
   call DrawBlock

MoveBFUA_End:
   pop xde   
   jp DoGrav_CheckNext

MoveButterFlyDownAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFDA_End
   cp (InViewY), 1
   jr nz, MoveBFDA_End

   push hl
   dec l
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MBFDA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc l
   ld a, TILEBLANK
   call DrawBlockAt
MBFDA1:
   pop hl

   ld a, TILEBUTTERFLY
   call DrawBlock

MoveBFDA_End:
   pop xde   
   jp DoGrav_CheckNext


MoveButterFlyLeftAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFLA_End
   cp (InViewY), 1
   jr nz, MoveBFLA_End
   
   push hl
   inc h
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MBFLA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec h
   ld a, TILEBLANK
   call DrawBlockAt
MBFLA1:
   pop hl

   ld a, TILEBUTTERFLY
   call DrawBlock

MoveBFLA_End:
   pop xde   
   jp DoGrav_CheckNext


MoveButterFlyRightAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveBFRA_End
   cp (InViewY), 1
   jr nz, MoveBFRA_End
   
   push hl
   dec h
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MBFRA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc h
   ld a, TILEBLANK
   call DrawBlockAt
MBFRA1:
   pop hl

   ld a, TILEBUTTERFLY
   call DrawBlock

MoveBFRA_End:
   pop xde   
   jp DoGrav_CheckNext




; ---------------------------------------------------------------
; BUTTERFLY HIT PLAYER
; ---------------------------------------------------------------
ButterFlyHitPlayer:
   push xde
   push hl

   ; remove player sprite from screen
   ldw hl, (PlayerY)
   push h
   ld h, 200
   calr DrawPlayer
   pop h

   ; remove player
   ld (xde), TILEBLANK

   ; draw explosion
   add h, (VisX)
   add l, (VisY)
   dec l
   dec h
   calr DrawExplosion

   ; set we're exploding flag to disable further joystick
   ld (DisableInput), 1
   ld (CountdownToLevelReset), 8

DoGrav_CheckButterHitSomething_End:
   pop hl
   pop xde
   jp CheckButterFlyUp_End



; ---------------------------------------------------------------
; DrawDiamondExplosion - takes hl as xy of top left of explosion
; draw a 3x3 explosion. Also updates map.
; If the tile where the explosion would be is solid wall then
; that tile is missed off.
; ---------------------------------------------------------------
DrawDiamondExplosion:
   push hl
   push bc
   push xde

   ld c, 0
DrawDiamondExp_YLoop:   
   ld b, 0

DrawDiamondExp_XLoop:
   calr ConvertXYtoMap
   
   cp (xde), TILESOLIDWALL ; don't explode solid wall
   jr z, DrawDiamondExp_NextX
   cp (xde), TILEEXIT
   jr z, DrawDiamondExp_NextX


   ld a, TILEDIAMOND
   calr DrawBlock

   ; was player hit?
   cp (xde), PLSTAND
   jr nz, DrawDiamondExp_1
   ld (xde), a
   push hl
   push h
   ld h, 200
   calr DrawPlayer ; remove player from screen
   pop h

   dec h
   dec l
   calr DrawExplosion
   ; set we're exploding flag to disable further joystick
   ld (DisableInput), 1
   ld (CountdownToLevelReset), 8
   pop hl

DrawDiamondExp_1:
   ; was firefly underneath
   ld w, (xde)
   and w, 15
   cp w, TILEFIREFLY
   jr nz, DrawDiamondExp_2

   ld (xde), a
   push hl
   dec h
   dec l
   calr DrawExplosion
   pop hl

DrawDiamondExp_2:
   ; was butterfly underneath
   ld w, (xde)
   and w, 15
   cp w, TILEBUTTERFLY
   jr nz, DrawDiamondExp_3

   ld (xde), a
   push hl
   dec h
   dec l
   calr DrawDiamondExplosion
   pop hl

DrawDiamondExp_3:
   ld (xde), a

DrawDiamondExp_NextX:
   inc h
   inc b
   cp b, 3
   jr nz, DrawDiamondExp_XLoop

   sub h, 3
   inc l
   inc c
   cp c, 3
   jr nz, DrawDiamondExp_YLoop

   pop xde
   pop bc
   pop hl
   ret



