; ---------------------------------------------------------------
; FireFly Handling
; These attempt to go anticlockwise
; ---------------------------------------------------------------

DoMoveFireFly:
   ; work out current direction
   ld a, (xde)
   and a, 0c0h
   cp a, FIREFLYRIGHT
   jp z, CheckFireFlyUp
   cp a, FIREFLYLEFT
   jp z, CheckFireFlyDown
   cp a, FIREFLYDOWN
   jp z, CheckFireFlyRight
   jp CheckFireFlyLeft ; FIREFLYUP

CheckFireFlyUp:
   push xbc
   ld xbc, xde
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckFireFlyUp_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckFireFlyRight:
   push xbc
   ld xbc, xde
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckFireFlyRight_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckFireFlyDown:
   push xbc
   ld xbc, xde
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckFireFlyDown_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

CheckFireFlyLeft:
   push xbc
   ld xbc, xde
   ; check left
   dec xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyLeft
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check up
   sub xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyUp
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check right
   inc xde
   cp (xde), TILEBLANK
   jp z, MoveFireFlyRight
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer
   ld xde, xbc
   ; check down
   add xde, MAXLEVELWIDTH
   cp (xde), TILEBLANK
   jp z, MoveFireFlyDown
   cp (xde), PLSTAND
   jp z, ButterFlyHitPlayer

CheckFireFlyLeft_End:
   ld xde, xbc
   pop xbc
   jp DoGrav_CheckNext

MoveFireFlyUp:
   push xde

   ; update the map
   ld a, TILEFIREFLYMOVED
   or a, FIREFLYUP ; set next direction
   ld (xde), a
   add xde, MAXLEVELWIDTH
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFU_End
   cp (InViewY), 1
   jr nz, MoveFFU_End
   
   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec l
   ld a, TILEFIREFLY
   call DrawBlockAt
   pop hl
   
MoveFFU_End:
   pop xde   
   jp CheckFireFlyUp_End


MoveFireFlyRight:
   push xde

   ; update the map
   ld a, TILEFIREFLYMOVED
   or a, FIREFLYRIGHT ; set next direction
   ld (xde), a
   dec xde
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFR_End
   cp (InViewY), 1
   jr nz, MoveFFR_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc h
   ld a, TILEFIREFLY
   call DrawBlockAt
   pop hl
   
MoveFFR_End:
   pop xde   
   jp CheckFireFlyRight_End


MoveFireFlyDown:
   push xde
   ; update the map
   ld a, TILEFIREFLYMOVED
   or a, FIREFLYDOWN ; set next direction
   ld (xde), a
   sub xde, MAXLEVELWIDTH
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFD_End
   cp (InViewY), 1
   jr nz, MoveFFD_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc l
   ld a, TILEFIREFLY
   call DrawBlockAt
   pop hl
   
MoveFFD_End:
   pop xde   
   jp CheckFireFlyDown_End


MoveFireFlyLeft:
   push xde

   ; update the map
   ld a, TILEFIREFLYMOVED
   or a, FIREFLYLEFT ; set next direction
   ld (xde), a
   inc xde
   ld (xde), TILEBLANK

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFL_End
   cp (InViewY), 1
   jr nz, MoveFFL_End

   ld a, TILEBLANK
   call DrawBlock
   push hl
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec h
   ld a, TILEFIREFLY
   call DrawBlockAt
   pop hl
   
MoveFFL_End:
   pop xde   
   jp CheckFireFlyLeft_End

; ---------------------------------------------------------------
; Fire Flies second animation
; ---------------------------------------------------------------
DoMoveFireFlyAnim:
   ; work out current direction
   and (xde), ~20h ; remove the moved flag
   ld a, (xde)
   and a, 0c0h
   cp a, FIREFLYRIGHT
   jp z, MoveFireFlyRightAnim
   cp a, FIREFLYLEFT
   jp z, MoveFireFlyLeftAnim
   cp a, FIREFLYDOWN
   jp z, MoveFireFlyDownAnim
   jp MoveFireFlyUpAnim ; FIREFLYUP

MoveFireFlyUpAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFUA_End
   cp (InViewY), 1
   jr nz, MoveFFUA_End
   
   push hl
   inc l
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MFFUA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec l
   ld a, TILEBLANK
   call DrawBlockAt
MFFUA1:
   pop hl

   ld a, TILEFIREFLY
   call DrawBlock

MoveFFUA_End:
   pop xde   
   jp DoGrav_CheckNext

MoveFireFlyDownAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFDA_End
   cp (InViewY), 1
   jr nz, MoveFFDA_End

   push hl
   dec l
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MFFDA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc l
   ld a, TILEBLANK
   call DrawBlockAt
MFFDA1:
   pop hl

   ld a, TILEFIREFLY
   call DrawBlock

MoveFFDA_End:
   pop xde   
   jp DoGrav_CheckNext


MoveFireFlyLeftAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFLA_End
   cp (InViewY), 1
   jr nz, MoveFFLA_End
   
   push hl
   inc h
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MFFLA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   dec h
   ld a, TILEBLANK
   call DrawBlockAt
MFFLA1:
   pop hl

   ld a, TILEFIREFLY
   call DrawBlock

MoveFFLA_End:
   pop xde   
   jp DoGrav_CheckNext


MoveFireFlyRightAnim:
   push xde

   ; if visible update screen
   cp (InViewX), 1
   jr nz, MoveFFRA_End
   cp (InViewY), 1
   jr nz, MoveFFRA_End
   
   push hl
   dec h
   calr ConvertXYToMap
   cp (xde), TILEBLANK
   jr nz, MFFRA1
   sub h, (VisX)
   sub l, (VisY)  
   sll 1, h
   sll 1, l
   inc h
   ld a, TILEBLANK
   call DrawBlockAt
MFFRA1:
   pop hl

   ld a, TILEFIREFLY
   call DrawBlock

MoveFFRA_End:
   pop xde   
   jp DoGrav_CheckNext



; ---------------------------------------------------------------
; FIREFLY HIT PLAYER
; ---------------------------------------------------------------
FireFlyHitPlayer:
   push xde
   push hl

   ; remove player sprite from screen
   ldw hl, (PlayerY)
   push h
   ld h, 200
   calr DrawPlayer
   pop h

   ; remove player
   ld (xde), TILEBLANK

   ; draw explosion
   add h, (VisX)
   add l, (VisY)
   dec l
   dec h
   calr DrawExplosion

   ; set we're exploding flag to disable further joystick
   ld (DisableInput), 1
   ld (CountdownToLevelReset), 8

DoGrav_CheckfirehitSomething_End:
   pop hl
   pop xde
   jp CheckFireFlyUp_End



